All of lore.kernel.org
 help / color / mirror / Atom feed
From: "Darrick J. Wong" <darrick.wong@oracle.com>
To: eguan@redhat.com, darrick.wong@oracle.com
Cc: linux-xfs@vger.kernel.org, fstests@vger.kernel.org
Subject: [PATCH 7/8] xfs: test freeze/rmap repair race
Date: Wed, 21 Jun 2017 14:58:11 -0700	[thread overview]
Message-ID: <149808229180.8924.4409973593099506918.stgit@birch.djwong.org> (raw)
In-Reply-To: <149808222258.8924.1682057078986741098.stgit@birch.djwong.org>

From: Darrick J. Wong <darrick.wong@oracle.com>

The rmapbt repair code plays some dirty tricks with the fs freezer to
avoid running afoul of regular xfs locking requirements.  Add a test to
check that filesystem write activities do not deadlock with the repair
program.

Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
---
 tests/xfs/1378     |  109 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/1378.out |    4 ++
 tests/xfs/group    |    1 
 3 files changed, 114 insertions(+)
 create mode 100755 tests/xfs/1378
 create mode 100644 tests/xfs/1378.out


diff --git a/tests/xfs/1378 b/tests/xfs/1378
new file mode 100755
index 0000000..79ba6bc
--- /dev/null
+++ b/tests/xfs/1378
@@ -0,0 +1,109 @@
+#! /bin/bash
+# FS QA Test No. 1378
+#
+# Race freeze and rmapbt repair for a while to see if we crash or livelock.
+# rmapbt repair requires us to freeze the filesystem to stop all filesystem
+# activity, so we can't have userspace wandering in and thawing it.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Oracle, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1335  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 7 15
+
+_cleanup()
+{
+	cd /
+	rm -rf $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/fuzzy
+. ./common/inject
+. ./common/xfs
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs xfs
+_require_xfs_scratch_rmapbt
+_require_xfs_io_command "scrub"
+_require_xfs_io_error_injection "force_repair"
+
+echo "Format and populate"
+_scratch_mkfs > "$seqres.full" 2>&1
+_scratch_mount
+
+STRESS_DIR="$SCRATCH_MNT/testdir"
+mkdir -p $STRESS_DIR
+
+for i in $(seq 0 9); do
+	mkdir -p $STRESS_DIR/$i
+	for j in $(seq 0 9); do
+		mkdir -p $STRESS_DIR/$i/$j
+		for k in $(seq 0 9); do
+			echo x > $STRESS_DIR/$i/$j/$k
+		done
+	done
+done
+
+cpus=$(( $(src/feature -o) * 4 * LOAD_FACTOR))
+
+echo "Concurrent repair"
+filter_output() {
+	egrep -v '(Device or resource busy|Invalid argument)'
+}
+freeze_loop() {
+	end="$1"
+
+	while [ "$(date +%s)" -lt $end ]; do
+		$XFS_IO_PROG -x -c 'freeze' -c 'thaw' $SCRATCH_MNT 2>&1 | filter_output
+	done
+}
+repair_loop() {
+	end="$1"
+
+	while [ "$(date +%s)" -lt $end ]; do
+		$XFS_IO_PROG -x -c 'repair rmapbt 0' -c 'repair rmapbt 1' $SCRATCH_MNT 2>&1 | filter_output
+	done
+}
+$XFS_IO_PROG -x -c 'inject force_repair' $SCRATCH_MNT
+
+start=$(date +%s)
+end=$((start + (30 * TIME_FACTOR) ))
+
+echo "Loop started at $(date --date="@${start}"), ending at $(date --date="@${end}")" >> $seqres.full
+freeze_loop $end &
+repair_loop $end &
+
+while [ "$(date +%s)" -lt $end ]; do
+	sleep 1
+done
+echo "Loop finished at $(date)" >> $seqres.full
+echo "Test done"
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/1378.out b/tests/xfs/1378.out
new file mode 100644
index 0000000..030e250
--- /dev/null
+++ b/tests/xfs/1378.out
@@ -0,0 +1,4 @@
+QA output created by 1378
+Format and populate
+Concurrent repair
+Test done
diff --git a/tests/xfs/group b/tests/xfs/group
index faf0095..d0a6831 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -419,3 +419,4 @@
 701 auto quick
 901 auto quick clone dedupe
 902 auto quick clone dedupe
+1378 dangerous_scrub dangerous_online_repair


  parent reply	other threads:[~2017-06-21 21:58 UTC|newest]

Thread overview: 34+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-06-21 21:57 [PATCH 0/8] miscellaneous tests Darrick J. Wong
2017-06-21 21:57 ` [PATCH 1/8] ext4: fsmap tests Darrick J. Wong
2017-06-23  7:41   ` Eryu Guan
2017-06-23 15:35     ` Darrick J. Wong
2017-06-21 21:57 ` [PATCH 2/8] xfs/274: flip shared bits to reflect xfsprogs usage Darrick J. Wong
2017-06-21 21:57 ` [PATCH 3/8] xfs: don't allow realtime swap files Darrick J. Wong
2017-06-21 21:57 ` [PATCH 4/8] xfs/040: use compare-libxfs in xfsprogs Darrick J. Wong
2017-06-21 21:57 ` [PATCH 5/8] reflink: test unlinking a huge extent with a lot of refcount adjustments Darrick J. Wong
2017-06-29  9:36   ` Eryu Guan
2017-06-29 16:07     ` Darrick J. Wong
2017-06-29 17:19       ` Eryu Guan
2017-06-21 21:57 ` [PATCH 6/8] xfs: test that we can SEEK_HOLE/DATA data and holes that are in the CoW fork only Darrick J. Wong
2017-06-21 21:58 ` Darrick J. Wong [this message]
2017-06-29  9:47   ` [PATCH 7/8] xfs: test freeze/rmap repair race Eryu Guan
2017-06-29 17:17     ` Darrick J. Wong
2017-06-21 21:58 ` [PATCH 8/8] xfs: scrub while appending to a file Darrick J. Wong
2017-06-22  6:26 ` [PATCH 9/8] common/populate: remember multi-device configurations Darrick J. Wong
2017-06-23  7:49   ` Eryu Guan
2017-06-23 15:34     ` Darrick J. Wong
2017-06-30  4:12   ` [PATCH v2 " Darrick J. Wong
2017-06-23  7:59 ` [PATCH 0/8] miscellaneous tests Eryu Guan
2017-06-30  4:12 ` [PATCH 10/8] common/rc: test that the xfs_io scrub/repair commands actually work Darrick J. Wong
2017-06-30  4:13 ` [PATCH 11/8] common/inject: refactor helpers to use new errortag interface Darrick J. Wong
2017-07-05 12:16   ` Brian Foster
2017-07-05 16:29     ` Darrick J. Wong
2017-07-05 16:45       ` Brian Foster
2017-07-05 21:05         ` Darrick J. Wong
2017-07-06 10:07           ` Brian Foster
2017-06-30  4:13 ` [PATCH 12/8] ext4: don't online scrub ever Darrick J. Wong
2017-06-30  4:22   ` Eryu Guan
2017-06-30  4:26     ` Darrick J. Wong
2017-06-30  4:33       ` Eryu Guan
2017-06-30  4:58   ` [PATCH v2 " Darrick J. Wong
2017-06-30 12:32     ` Eryu Guan

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=149808229180.8924.4409973593099506918.stgit@birch.djwong.org \
    --to=darrick.wong@oracle.com \
    --cc=eguan@redhat.com \
    --cc=fstests@vger.kernel.org \
    --cc=linux-xfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.